import sqlite3


class Engine:
    def __init__(self, database):
        """
        :param database: 数据库
        :type database: str
        """
        self.con = sqlite3.connect(database)
        self.cur = self.con.cursor()

    def get(self, table, pk):
        """
        :param table: 数据表
        :type table: str
        :param pk: 主键
        :type pk: int
        :return: 一条匹配的行
        :rtype: tuple
        """
        sql = f'select * from {table} where id = {pk};'
        self.cur.execute(sql)
        return self.cur.fetchone()

    def filter(self, table, method=0, **kwargs):
        """
        :param table: 数据表
        :type table: str
        :param method: 匹配模式（0为精准匹配，1为相似匹配）
        :type method: int
        :keyword kwargs: 条件
        :return: 多个匹配行的列表
        :rtype: list[tuple]
        """
        cond = ' and '.join([f'{k} {"like" if method else "="} "{f"%{v}%" if method else v}"' for k, v in kwargs.items()])
        sql = f'select * from {table} where {cond or 1};'
        self.cur.execute(sql)
        return self.cur.fetchall()

    def __del__(self):
        self.cur.close()
        self.con.close()
